@startuml
title (4-5)a modifyData
actor Actor
participant "CatERingAppManager.eventManager:EventManager" as em
participant "eventManager.currentEvent:Event" as e
participant "r:EventReceiver" as r

Actor -> em ++: modifyData(name?,date?,location?,numberOfParticipants?,serviceType?,tipologyNote?)

alt currentEvent == null
	em -->> Actor: Throw UseCaseLogicException
else event.getChef() != null && \n event.getMenu() != null
  em -->> Actor: throw EventException
else
	opt
		em -> e ++: setName(name) 
    	deactivate e
    end
    
	opt
		em -> e ++: setDate(date) 
    	deactivate e
    end
    
    opt
		em -> e ++: setLocation(location) 
    	deactivate e
    end
    
    opt
		em -> e ++: setNumberOfParticipants(numberOfParticipants) 
    	deactivate e
    end
    
    opt
		em -> e ++: setServiceType(serviceType) 
    	deactivate e
    end
    
    opt
		em -> e ++: setTipologyNote(tipologyNote) 
    	deactivate e
    end
    
    group for each r in receivers
    	em -> r++:notifyDataModified(currentEvent)
        deactivate r
    end 
    
    Actor <-- em--
end
@enduml
